function fid = vis_3D_correspondence(M,N,matching)
% matching is a vector of length M.n, assigning each point in M a
% corresponding point in N. Some points in N may not be hit, others
% multiple times


if (~isfield(M,'gt'))
    M.gt = 1:M.n;
end

if (~isfield(N,'gt'))
    N.gt = 1:N.n;
end


if (~isfield(M,'gti'))
    M.gti = invPerm(M.gt);
end

if (~isfield(N,'gti'))
    N.gti = invPerm(N.gt);
end


% 
% 
matching_gt = get_gt(M,N);
matching_gti = get_gt(N,M);


% Via Color transfer

colorsM = create_colormap(M,M);

subplot(2,2,1)
scatter3(M.VERT(:,1),M.VERT(:,2),M.VERT(:,3),30,colorsM,'filled');axis equal;axis off
title('Input coloring on M')

subplot(2,2,2)
colorsN = zeros(N.n,3);
for i=1:M.n
    colorsN(matching(i),:) = colorsM(i,:);
end
scatter3(N.VERT(:,1),N.VERT(:,2),N.VERT(:,3),30,colorsN,'filled');axis equal;axis off
title('Transfered to N, black=non-hit')
% 

colorsN = create_colormap(N,N);
colorsM = colorsN(matching,:);

subplot(2,2,3)
scatter3(M.VERT(:,1),M.VERT(:,2),M.VERT(:,3),30,colorsM,'filled');axis equal;axis off
title('Transfered to M')

subplot(2,2,4)
scatter3(N.VERT(:,1),N.VERT(:,2),N.VERT(:,3),30,colorsN,'filled');axis equal;axis off
title('Input coloring on N')



end